 ###############################################
#                                               #
#                T I M E I T !                  #
#       v1.0 (08/06/2009)  par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.epiknet.org  #boulets        #
#              irc.teepi.net    #boulets        #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################

#
# Syntaxe : .TimeIt <nombre de rptitions> <commandes>
#
# Description :
# TimeIt! permet de chronomtrer le temps d'excution d'une commande, d'une
# procdure, etc...
# TimeIt! peut tre utilis en partyline ou sur un chan, mais l'accs  la
# commande publique est scuris et ncessite que vous soyez connect  la
# partyline (donc identifi).
#	
# Exemple :
#		<MenzAgitat> .TimeIt 1000 regsub -all {(.)\1{1,}} "ceci est un test" {\1}
#		<Boole> Temps d'excution sur 1000 itrations : 1.609s (0.001609s par itration)
#

#
#	Changelog
#		1.0 	- 1re version
#

#
# LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#

if { [lindex [split $version] 1] < 1061800 } { putloglev o * "\00304\002\[TimeIt! - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; TimeIt.tcl ne fonctionnera correctement que sur les eggdrops version\002 1.6.18\002 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putloglev o * "\00304\002\[TimeIt! - ERREUR\]\002\003 TimeIt.tcl ncessite que \002Tcl 8.4\002 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.4
if {[info commands TimeIt::uninstall] eq "::TimeIt::uninstall"} { TimeIt::uninstall }
namespace eval TimeIt {

	###########################
	#				PARAMETRES        #
	###########################

	# Commande en partyline (devra tre tape prcde d'un ".")
	variable PL_cmd "TimeIt"
	# Autorisations pour la commande en partyline
	variable PL_auth "m|m"
	# Commande publique :
	variable public_cmd ".TimeIt"
	# Autorisations pour la commande publique :
	variable public_auth "m|m"
	



####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	variable scriptname "TimeIt!"
  variable version "1.0.20090608"
	bind dcc $PL_auth $PL_cmd TimeIt::dcc_chronoprocess
	bind pub $public_auth $public_cmd TimeIt::pubm_chronoprocess
	bind evnt - prerehash TimeIt::uninstall
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$TimeIt::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " (::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		namespace delete ::TimeIt
	}
}

proc TimeIt::dcc_chronoprocess {hand idx arg} {
	if { ($arg eq "") || (![regexp {^[0-9]+$} [lindex $arg 0]])} { putlog "\037Syntaxe\037 : .$TimeIt::PL_cmd \00314<\003nombre de rptitions\00314><\003commandes\00314>\003" ; return }
	set chrono_timestart [clock clicks -milliseconds]
	for { set chrono_counter 1 } { $chrono_counter <= [lindex $arg 0] } { incr chrono_counter } { eval [lrange $arg 1 end] }
	putlog "\00314Temps d'excution sur [lindex $arg 0] itrations :\003 [set chrono_total_time [expr [expr [clock clicks -milliseconds]-$chrono_timestart]/1000.00]]s \00314(\003\002\002[expr $chrono_total_time / [lindex $arg 0]]s\00314 par itration)"
}

proc TimeIt::pubm_chronoprocess {nick host hand chan arg} {
	if {([set index [hand2idx $hand]] == -1) || ([console $index] eq "")} {
		putserv "NOTICE $nick :\00314Action non-autorise. Veuillez vous connecter  la partyline et vous identifier.\003"
		return
	}
	if { ($arg eq "") || (![regexp {^[0-9]+$} [lindex $arg 0]])} { putquick "PRIVMSG $chan :\037Syntaxe\037 : $TimeIt::public_cmd \00314<\003nombre de rptitions\00314><\003commandes\00314>\003" ; return }
	set chrono_timestart [clock clicks -milliseconds]
	for { set chrono_counter 1 } { $chrono_counter <= [lindex $arg 0] } { incr chrono_counter } { eval [lrange $arg 1 end] }
	putquick "PRIVMSG $chan :\00314Temps d'excution sur [lindex $arg 0] itrations :\003 [set chrono_total_time [expr [expr [clock clicks -milliseconds]-$chrono_timestart]/1000.00]]s \00314(\003\002\002[expr $chrono_total_time / [lindex $arg 0]]s\00314 par itration)"
}


putlog "\002*$TimeIt::scriptname v$TimeIt::version*\002 par MenzAgitat a t charg."
